{% extends 'base.html.twig' %}

{% block title %}Undercover - Jeu de l'imposteur en ligne multijoueur{% endblock %}

{% block stylesheets %}
    <style>
        @import url('https://fonts.googleapis.com/css2?family=Roboto&family=Squada+One&display=swap%27');
        @import url('https://fonts.googleapis.com/css2?family=DM+Sans:wght@700&display=swap%27');

        *, ::after, ::before {
            box-sizing: border-box;
        }

        html, body {
            width: 100vw;
            height: 100vh;
            margin: 0;
            font-family: 'Roboto', sans-serif !important;
            overflow: hidden;
            background: #0a0717;
            color: white;
            line-height: 1.5;
        }

        main {
            position: relative;
            width: 100%;
            height: 100%;
        }

        main .squares {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%) rotate(45deg);
            width: 1350px;
            height: 1350px;

        }

        main .squares .square:nth-child(1) {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 100%;
            height: 100%;
            background-color: #EBD834;
            transition: all .2s;

        }

        main .squares .square:nth-child(2) {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: calc(100% - 300px);
            height: calc(100% - 300px);
            background-color: #0A0717;
            transition: all .2s;

        }

        main.animated .squares .square:nth-child(1) {
            width: 156%;
            height: 156%;
        }

        main.animated .squares .square:nth-child(2) {
            width: calc(156% - 300px);
            height: calc(156% - 300px);
        }

        #main-center {
            position: relative;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 80vw;
            height: 90vh;
        }

        #main-top {
            position: relative;
            height: 80%;
            display: flex;
            flex-direction: column;
            justify-content: space-between;
        }

        #main-top.rain {
            box-shadow: inset 00px -10px 100px 100px #0a0717;
            background: radial-gradient(
                    circle,
                    rgba(10, 7, 23, 0.12648809523809523) 0%,
                    rgba(10, 7, 23, 0.4906337535014006) 31%,
                    rgba(10, 7, 23, 1) 78%),
            url('https://puu.sh/GKPEg/dad8e6a5c6.gif') no-repeat;
            background-size: cover;
            background-position: center;
        }

        #main-top.car {
            box-shadow: inset 00px -10px 100px 100px #0a0717;
            background: radial-gradient(
                    circle,
                    rgba(10, 7, 23, 0.12648809523809523) 0%,
                    rgba(10, 7, 23, 0.4906337535014006) 31%,
                    rgba(10, 7, 23, 1) 78%),
            url('https://cdn.discordapp.com/attachments/293803324875079680/774670872920981544/easyloader-min.png') no-repeat;
            background-size: cover;
            background-position: center;
        }

        #main-bottom {
            display: flex;
            justify-content: center;
            align-items: center;
            height: 20%;
        }

        #main-header {
            display: flex;
            justify-content: space-between;
            padding: 0 150px;
            align-items: center;
            height: 97px;
        }

        #main-header-left {
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
            text-transform: uppercase;
            font-weight: bold;
            color: white;
        }

        #main-header-left div:nth-child(2) {
            font-size: 30px;
        }

        #main-header-center {
            position: absolute;
            top: 0;
            left: 50%;
            transform: translateX(-50%);
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            color: white;
            font-weight: bold;
            text-transform: uppercase;
        }

        #main-header-right {
            display: flex;
            flex-direction: row;
            justify-content: center;
            align-items: center;
            flex: 0 0 100px;
            font-weight: bold;
        }

        #guess-word {
            padding: 6px 50px;
            background: #191139;
            color: white;
            font-size: 30px;
            border-radius: 15px;
            min-width: 230px;
            text-align: center;
            text-transform: uppercase;
            font-weight: bold;
            letter-spacing: 1.5px;
            position: relative;
            z-index: 1;
            box-shadow: 0 15px 10px -15px black;
        }

        #role {
            padding: 8px 40px 5px 40px;
            color: white;
            font-size: 18px;
            border-radius: 0 0 8px 8px;
            text-transform: uppercase;
            font-weight: bold;
            letter-spacing: 1.5px;
            display: none;
        }

        #role.undercover {
            background: #51000B;
            color: white;
        }

        #role.mrWhite {
            background: #cccccc;
            color: #191625;
        }

        #role.civil {
            background: #26538C;
            color: white;
        }

        #help {
            display: flex;
            justify-content: center;
            align-items: center;
            background: transparent;
            font-size: 24px;
            font-weight: bold;
            color: white;
            width: 50px;
            height: 50px;
            border-radius: 100%;
            border: solid 2px white;
            text-transform: uppercase;
            letter-spacing: 1.5px;
            outline: none;
            cursor: pointer;
            transition: all .2s;
        }

        #help:hover {
            background: rgba(255, 255, 255, .12);
        }

        #characters {
            width: 100%;
            display: flex;
            justify-content: space-around;
            align-items: center;
        }

        #input-text {
            display: none;
            flex-direction: column;
            align-items: center;
        }

        #input-word {
            padding: 10px 50px;
            background: white;
            color: black;
            font-size: 20px;
            border-radius: 10px 10px 0 0;
            text-transform: uppercase;
            border: none;
            text-align: center;
            font-weight: bold;
            outline: none;
            font-family: inherit;
            line-height: inherit;
        }

        .img-writing {
            width: 20px !important;
            display: none;
        }

        #input-word::placeholder {
            font-size: 13px;
            text-transform: uppercase;
            color: #5d5d5d;
            text-align: center;
            font-weight: bold;
        }

        #timer-me {
            width: 100%;
            height: 10px;
            background: #59556f;
            border-radius: 0 0 5px 5px;
            margin-top: -2px;
        }

        #timer-full {
            width: 0;
            height: 10px;
            background: #26213E;
            border-radius: 0 0 5px 5px;
            transition: all 1.0s;
        }

        /*#button-action*/
        /*{*/
        /*    display:flex;*/
        /*    flex-direction:column;*/
        /*    align-items:center;*/
        /*}*/

        .container-char {
            display: flex;
            align-items: center;
            flex-direction: column;
            flex-wrap: wrap;
            text-align: center;
            position: relative;
            width: 170px;
            animation: active-anim 0.8s ease-out;
            animation-fill-mode: forwards;
        }

        .active-player {
            background: radial-gradient(
                    ellipse,
                    rgb(250 248 255 / 37%) 0%,
                    rgb(250 248 255 / 10%) 40%,
                    rgb(255 255 255 / 0%) 65%);
        }

        .active-player-small {
            background: radial-gradient(
                    circle,
                    rgb(250 248 255 / 37%) 0%,
                    rgb(250 248 255 / 10%) 29%,
                    rgb(255 255 255 / 0%) 50%);
            background-position: 0px 35px;
        }

        .container-char img {
            width: 75%;
            user-select: none;
        }

        .nb-vote {
            position: absolute;
            bottom: 100%;
            left: 50%;
            width: 40px;
            display: none;
            /*display: flex;*/
            align-items: center;
            justify-content: center;
            height: 40px;
            border-radius: 30px;
            background: rgba(107 36 36 / 75%);
            text-align: center;
            color: white;
            font-weight: bold;
            padding: 16px;
            z-index: 1;
            transform: translate(-50%, -20px);
        }

        .popup-word {
            position: absolute;
            bottom: calc(100% + 30px);
            left: 0;
            height: 200px;
            padding: 16px;
            display: none;
            cursor: pointer;
            background: rgba(31 31 46 / 88%);
            border-radius: 10px;
            color: white;
            text-align: center;
            overflow-Y: auto;
        }

        .popup-word::-webkit-scrollbar-track {
            -webkit-box-shadow: none;
            border-radius: 10px;
            background-color: transparent;
        }

        .popup-word::-webkit-scrollbar {
            width: 6px;
            background-color: transparent;
        }

        .popup-word::-webkit-scrollbar-thumb {
            border-radius: 10px;
            -webkit-box-shadow: none;
            height: 100px;
            background-color: #171721;
        }

        .popup-word-title {
            width: 100%;
            text-transform: uppercase;
            font-weight: bold;
            font-size: 15px;
            padding-bottom: 5px;
            border-bottom: solid 2px white;
        }

        .old-word {
            margin-top: 7px;
            width: 100%;
            text-align: left;
            text-overflow: ellipsis;
            white-space: nowrap;
            overflow: hidden;
            font-size: 12px;
        }

        .old-word p {
            margin: 0;
            text-overflow: ellipsis;
            white-space: nowrap;
            overflow: hidden;
        }

        .old-word span.tour-title {
            font-weight: bold;
            color: #7e5efd;
        }

        .old-word span.tour-word {
            text-overflow: ellipsis;
            white-space: nowrap;
            overflow: hidden;
        }

        .word-typed {
            position: relative;
            max-width: 130px;
            border-radius: 5px;
            cursor: pointer;
            background: white;
            text-align: center;
            padding: 8px 10px;
            text-transform: uppercase;
            font-size: 12px;
            font-weight: bold;
            animation: float 6s ease-in-out infinite;
            color: black;
            min-width: 100px;
            min-height: 34px;
        }

        .word-typed::after {
            content: "";
            width: 10px;
            height: 10px;
            position: absolute;
            top: 100%;
            left: 50%;
            transform: translate(-50%, -50%) rotate(45deg);
            background: white;
        }

        .pseudo {
            color: white;
            text-transform: uppercase;
            font-size: 16px;
            font-weight: bold;
            margin-top: -20px;
            cursor: pointer;
        }

        .word-typed.disconnect {
            filter: blur(4px);
        }

        .img-char.disconnect {
            filter: blur(3px);
        }

        .container-char.disconnect::after {
            content: 'Deconnecté';
            padding: 5px 10px;
            position: absolute;
            top: 60%;
            right: 50%;
            border-radius: 5px;
            filter: blur(0px);
            color: white;
            background: #191139;
            transform: translate(50%, 0%);
            text-transform: uppercase;
            font-weight: bold;
            font-size: 13px;
            letter-spacing: 0.5px
        }

        @keyframes float {
            0% {
                transform: translatey(0px);
            }
            50% {
                transform: translatey(-10px);
            }
            100% {
                transform: translatey(0px);
            }
        }

        #main-popup {
            display: none;
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgb(12 11 16 / 85%);
            z-index: 1;
        }

        #main-popup-hud {
            display: none;
            position: absolute;
            top: 45%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 60vw;
            height: 75vh;
            background-color: rgb(16 15 25 / 99%);
            min-width: 800px;
            z-index: 1;
            border-radius: 10px;
            overflow: hidden;
        }


        #main-popup-hud-header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
            align-items: center;
        }

        #main-popup-hud-title {
            width: 80%;
            padding: 20px 40px;
            font-size: 23px;
            color: white;
            font-weight: bolder

        }

        #main-popup-hud-close {
            width: 20%;
            text-align: right;
            font-size: 20px;
            padding: 20px 30px;
            color: white;
            text-transform: uppercase;
            font-weight: bold;
        }

        #main-popup-hud-close button {
            width: 40px;
            border: solid 3px white;
            height: 40px;
            background: transparent;
            border-radius: 40px;
            color: white;
            outline: none;
            cursor: pointer;
            transition: all .2s;
        }

        #main-popup-hud-close button:hover {
            background: rgba(255, 255, 255, .12);
        }


        #main-popup-long {
            display: flex;
            flex-direction: row;
            width: 100%;
            padding: 10px 30px;
            justify-content: center;
        }


        .char-general {
            width: 100%;
            padding: 10px;
            display: flex;
            align-items: center;
            text-align: center;
            flex-direction: column;
        }

        .char-avatar {
            width: 70px;
            height: 70px;
            border-radius: 70px;
        }

        .char-name {
            text-align: center;
            width: 100%;
            color: white;
            padding: 15px 0;
            font-size: 10px;
            font-weight: bold;
            text-transform: uppercase;
            letter-spacing: 1px;
        }

        .char-vote {
            text-align: center;
            width: 100%;
            color: white;
            padding: 5px 0;
            font-size: 10px;
            font-weight: bold;
            text-transform: uppercase;
            letter-spacing: 1px;
        }

        .char-vote-btn {
            max-width: 220px;
            width: 100%;
            height: 30px;
            color: white;
            background: #670a0a;
            border-radius: 3px;
            font-size: 13px;
            text-transform: uppercase;
            font-weight: bold;
            border: none;
            transition: all .2s;
            margin-bottom: 10px;
        }

        .char-vote-btn:hover {
            background: #821a1a;
        }

        .char-vote-btn:focus {
            background: #1d560e;
            outline: none;
        }

        .char-avatar-voter {
            width: 40px;
            height: 40px;
            border-radius: 100%;
            border: solid 3px #f3f3f3;
            cursor: help;
            transition: all .3s;
        }

        .char-avatar-voter + .char-avatar-voter {
            margin-top: 5px;
        }

        .char-avatar-voter:hover {
            border: solid 3px #670a0a;
        }

        #validate-vote-btn {
            position: absolute;
            z-index: 1;
            bottom: 0;
            width: 100%;
            height: 10%;
            align-items: center;
            justify-content: center;
            text-align: center;
            display: flex;
        }

        #validate-vote-btn button {
            width: 300px;
            height: 50px;
            background: #09090e;
            color: white;
            border-radius: 10px;
            outline: none;
            border: 0;
            transition: all .1s;
        }

        #validate-vote-btn button:hover {
            background: white;
            color: black;
        }

        #action {
            display: none;
            flex-direction: column;
            align-items: center;
        }

        #action-btn {
            padding: 10px 50px;
            background: white;
            color: #0a0717;
            font-size: 20px;
            border-radius: 10px;
            text-transform: uppercase;
            border: none;
            text-align: center;
            font-weight: bold;
            outline: none;
            cursor: pointer;
            font-family: inherit;
            line-height: inherit;
        }

        #action-btn:hover {
            transition: all 0.2s;
            color: #573dbd;
        }

        .show-input-text {
            display: flex !important;
        }

        .show-owner-btn {
            display: flex !important;
        }

        .profile {
            background: #f3f3f3;
            position: relative;
            overflow: hidden;
        }

        .profile .top-profile-img {
            position: absolute;
            width: 100px;
            top: -25px;
            left: -15px;
        }

        .profile .profile-voter {
            position: absolute;
            width: 60px;
            top: -20px;
            left: -14px;
        }

        #victory-overlay {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            display: none;
            height: 100%;
            z-index: 8;
            animation: fadetoblack 1s ease-in-out;
            animation-fill-mode: forwards;
        }

        #victory-overlay-hud {
            position: absolute;
            top: 45%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 20vw;
            height: 50vh;
            background: url('https://cdn.discordapp.com/attachments/293803324875079680/775065178508361755/firework.gif') no-repeat;
            background-size: 80%;
            background-position: center -60px;
            min-width: 800px;
            z-index: 8;
            display: none;
            justify-content: center;
            text-align: center;
            align-items: center;
            opacity: 0;
            animation: logoreveal 1s ease-in-out 0.5s;
            animation-fill-mode: forwards;
            flex-direction: column;
        }

        #victory-overlay-hud img {
            opacity: 0;
            animation: logoreveal 1s ease-in-out 0.5s;
            animation-fill-mode: forwards;
        }

        #button-end {
            margin-top: 30px;
            width: 50%;
        }

        #button-end button {
            border: none;
            outline: none;
            padding: 10px 40px;
            margin: 20px;
            border-radius: 5px;
            background: #1b1631;
            color: white;
            font-weight: bold;
            text-transform: uppercase;
            font-size: 13px;
            transition: all .2s;
            opacity: 0;
            animation: logoreveal 1s ease-in-out 1.5s;
            animation-fill-mode: forwards;
            line-height: inherit;
            font-family: inherit;
        }

        #button-end button:hover {
            background: #2a224a;
        }

        #button-end .waiting:hover {
            background: #1b1631;
        }

        @keyframes fadetoblack {
            0% {
                background-color: rgb(12 11 16 / 0%);
            }
            100% {
                background-color: rgb(12 11 16 / 98%);
            }
        }

        @keyframes fadetolightgrey {
            0% {
                background-color: rgb(12 11 16 / 0%);
            }
            100% {
                background-color: rgb(12 11 16 / 30%);
            }
        }

        @keyframes logoreveal {
            0% {
                opacity: 0;
            }
            100% {
                opacity: 100%;
            }
        }

        #mrWhiteLeft {
            display: flex;
            align-items: center;
            justify-content: center;
            margin-right: 17px;
        }

        #undercoverLeft {
            display: flex;
            align-items: center;
            justify-content: center;
        }

        #main-header-right img {
            width: 40px;
            margin-right: 5px;
        }


        #mrwhite-overlay {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            z-index: 1;
            display: none;
            animation: fadetoblackhud 0.5s ease-in-out;
            animation-fill-mode: forwards;
        }

        /* --------------------------------------- */

        #container-mrwhite {
            position: absolute;
            top: 45%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 600px;
            height: 350px;
            border-radius: 20px;
            background: #1C1C2B;
            z-index: 1;
            display: none;
            flex-direction: row;
        }

        #timer-container-mrwhite {
            width: 220px;
            border-radius: 20px 0 0 20px;
            height: 100%;
            background: #100D1C;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: space-evenly;
        }

        .circle-skin-mrwhite {
            width: 120px;
            height: 120px;
            background: white;
            border-radius: 150px;
            overflow: hidden;
            position: relative;
            border: solid 10px white;
        }

        .circle-skin-mrwhite img {
            width: 100%;
            position: absolute;
            top: -15px;
        }

        #timer-mrwhite {
            width: 180px;
            height: 70px;
            text-align: center;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 80px;
            font-weight: bold;
            padding-bottom: 10px;
            letter-spacing: 2px;
            color: white;
            animation: decompte 1s ease-in-out infinite;
        }

        #timer-others {
            width: 180px;
            height: 70px;
            text-align: center;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 80px;
            font-weight: bold;
            padding-bottom: 10px;
            letter-spacing: 2px;
            color: white;
            animation: decompte 1s ease-in-out infinite;
        }

        @keyframes decompte {
            0% {
                transform: scale(0.8);
                opacity: 0;
            }
            30% {
                opacity: 1
            }
            100% {
                transform: scale(1);
            }
        }

        #guessword-mrwhite {
            width: 100%;
            height: 100%;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            color: white;
            text-transform: uppercase;
            font-weight: bold;
            letter-spacing: 0.5px;

        }

        #guessword-mrwhite input {
            width: 300px;
            display: flex;
            height: 60px;
            background: white;
            outline: none;
            border: 0;
            border-radius: 20px;
            padding: 20px;
        }

        #guessword-mrwhite button {
            width: 200px;
            background: #191139;
            outline: none;
            border: 0;
            border-radius: 10px;
            margin-top: 40px;
            padding: 10px;
            text-transform: uppercase;
            font-size: 12px;
            font-weight: bold;
            letter-spacing: 0.2px;
            color: white;
            line-height: inherit;
            font-family: inherit;
        }

        #guessword-mrwhite button:hover {
            background: #25175a;
            cursor: pointer;
        }

        #container-waitfor-mrwhite {
            position: absolute;
            top: 45%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 250px;
            height: 400px;
            border-radius: 20px;
            background: #100D1C;
            z-index: 1;
            display: none;
            flex-direction: column;
            align-items: center;
            text-align: center;
            justify-content: center;
        }

        #text-waitfor-mrwhite {
            width: 100%;
            color: white;
            text-transform: uppercase;
            font-weight: bold;
            padding: 20px;
            display: flex;
            align-items: center;
            text-align: center;
            justify-content: center;
            flex-direction: column;
        }

        #title-waitfor-mrwhite {
            color: white;
            font-size: 30px;
        }

        .circle-skin-waitfor-mrwhite {
            width: 120px;
            margin-bottom: 20px;
            height: 120px;
            background: white;
            display: flex;
            border-radius: 150px;
            overflow: hidden;
            position: relative;
            border: solid 10px white;
        }

        .valid-mh {
            border: solid 10px #1e8435;
        }

        .invalid-mh {
            border: solid 10px #92010f;
        }

        .circle-skin-waitfor-mrwhite img {
            width: 100%;
            position: absolute;
            top: -15px;
        }

        /* --------------------------------------- */

        @keyframes fadetoblackhud {
            0% {
                background-color: rgb(12 11 16 / 0%);
            }
            100% {
                background-color: rgb(12 11 16 / 83%);
            }
        }

        #container-card {
            display: none;
            position: absolute;
            top: 45%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 280px;
            height: 400px;
            z-index: 1;

        }

        .revealUndercover {
            position: absolute;
            top: 0%;
            transform: translate(-50%, -50%);
            width: 280px;
            height: 400px;
            background: #100D1C;
            border-radius: 20px;
            z-index: 1;
            padding: 50px;
            display: flex;
            align-items: center;
            flex-direction: column;
            animation: returncardundercover ease-in-out;
            animation-duration: 2s;
            animation-fill-mode: forwards;
            transform-style: preserve-3d;
            -webkit-backface-visibility: hidden;
            backface-visibility: hidden;

        }

        .revealMrWhite {
            position: absolute;
            top: 0%;
            transform: translate(-50%, -50%);
            width: 280px;
            height: 400px;
            background: #100D1C;
            border-radius: 20px;
            z-index: 1;
            padding: 50px;
            display: flex;
            align-items: center;
            flex-direction: column;
            animation: returncardmrwhite ease-in-out;
            animation-duration: 2s;
            animation-fill-mode: forwards;
            transform-style: preserve-3d;
            -webkit-backface-visibility: hidden;
            backface-visibility: hidden;
        }

        .revealCivil {
            position: absolute;
            top: 0%;
            transform: translate(-50%, -50%);
            width: 280px;
            height: 400px;
            background: #100D1C;
            border-radius: 20px;
            z-index: 1;
            padding: 50px;
            display: flex;
            align-items: center;
            flex-direction: column;
            animation: returncardcivils ease-in-out;
            animation-duration: 2s;
            animation-fill-mode: forwards;
            transform-style: preserve-3d;
            -webkit-backface-visibility: hidden;
            backface-visibility: hidden;
        }

        #card-reveal-front {
            position: relative;
            transform: translate(-50%, -50%);
            width: 280px;
            height: 400px;
            background: #100D1C;
            border-radius: 20px;
            z-index: 1;
            padding: 50px;
            display: flex;
            align-items: center;
            flex-direction: column;
            animation: returncardback ease-in-out;
            animation-duration: 2s;
            animation-fill-mode: forwards;
            transform-style: preserve-3d;
            opacity: 0;
            -webkit-backface-visibility: hidden;
            backface-visibility: hidden;
        }

        @keyframes returncardback {
            0% {
                transform: scale(0.5) rotateY(0deg);
                opacity: 0;
            }
            30% {
                opacity: 1;
            }
            100% {
                transform: scale(1) rotateY(180deg);
            }
        }

        @keyframes returncardundercover {
            0% {
                transform: scale(0.5) rotateY(-180deg);
            }
            60% {
                box-shadow: 0px 0px 30px 2px #ffffff00;
            }
            100% {
                transform: scale(1) rotateY(0deg);
                box-shadow: 0px 0px 30px 2px #e40404;
            }
        }

        @keyframes returncardmrwhite {
            0% {
                transform: scale(0.5) rotateY(-180deg);
            }
            60% {
                box-shadow: 0px 0px 30px 2px #ffffff00;
            }
            100% {
                transform: scale(1) rotateY(0deg);
                box-shadow: 0px 0px 30px 2px white;
            }
        }

        @keyframes returncardcivils {
            0% {
                transform: scale(0.5) rotateY(-180deg);
            }
            60% {
                box-shadow: 0px 0px 30px 2px #ffffff00;
            }
            100% {
                transform: scale(1) rotateY(0deg);
                box-shadow: 0px 0px 30px 2px #378eff;
            }
        }


        .circle-face-reval {
            width: 150px;
            height: 150px;
            background: white;
            border-radius: 150px;
            overflow: hidden;
            position: relative;
        }

        .circle-face-reval img {
            width: 100%;
            position: absolute;
            top: -30px;
        }


        #card-pseudo {
            width: 100%;
            display: flex;
            color: white;
            align-items: center;
            justify-content: center;
            margin-top: 20px;
            text-align: center;
            flex-direction: column;
        }

        #card-pseudo-name {
            max-width: 280px;
            padding: 0px 30px;
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
        }

        #card-role {
            font-family: 'DM Sans', sans-serif;
            width: 100%;
            display: flex;
            font-size: 25px;
            text-transform: uppercase;
            font-weight: bold;
            color: white;
            align-items: center;
            justify-content: center;
            margin-top: 30px;
            text-align: center;
        }

        @keyframes active-anim {
            0% {
                transform: scale(0.5);
            }

            100% {
                transform: scale(1);
            }
        }

        #container-equality {
            position: absolute;
            display: none;
            top: 45%;
            left: 50%;
            width: 550px;
            height: 200px;
            transform: translate(-50%, -50%);
            z-index: 1;

        }

        #equality-popup {
            width: 550px;
            height: 200px;
            border-radius: 20px;
            background: #16151b;
            z-index: 1;
            display: flex;
            flex-direction: column;
            align-items: center;
            text-align: center;
            justify-content: center;
            animation: equality ease-out;
            animation-duration: 2s;
            animation-fill-mode: forwards;

        }

        #logo-equality {
            width: 100px;
            position: absolute;
            top: -45px;
            margin-left: -10px;
            cursor: default;
        }

        #logo-equality img {
            width: 100%;
        }

        #equality-text {
            width: 70%;
            display: flex;
            height: 200px;
            padding: 20px;
            padding-top: 60px;
            align-items: center;
            text-align: center;
            justify-content: center;
            flex-direction: column;
            color: white;
            text-transform: uppercase;
            font-weight: bold;
        }

        #equality-text h4 {
            cursor: default;
            text-transform: uppercase;
            font-size: 30px;
            font-weight: bold;
            letter-spacing: 1.2px;
        }

        #equality-text p {
            cursor: default;
            font-size: 12px;
        }

        @keyframes equality {
            0% {
                transform: scale(0.7);
                opacity: 0.5;
            }

            20% {
                opacity: 1;
            }
            100% {
                transform: scale(1);
            }
        }

    </style>
{% endblock %}

{% block body %}
    <main class="">
        <div id="main-center">
            <div id="main-top" class="car">
                <div id="main-header">
                    <div id="main-header-left">
                        <div>Tour <span id="current-turn">1</span></div>
                        <div>00:<span id="counter">00</span></div>
                    </div>
                    <div id="main-header-center">
                        <div id="guess-word">
                            EN ATTENTE ...
                        </div>
                        <div id="role"></div>
                    </div>
                    <div id="main-header-right">
                        {% if roomUndercover.isMrWhite is same as true %}
                            <div id="mrWhiteLeft">
                                <img src="{{ asset('assets/images/form/white.svg') }}" alt="">
                                <div><span id="countMrWhite">1</span>/1</div>
                            </div>
                        {% endif %}
                        <div id="undercoverLeft">
                            <img src="{{ asset('assets/images/form/undercover.svg') }}" alt="">
                            <div><span id="countUndercover">1</span>/{{ roomUndercover.nbUndercover }}</div>
                        </div>
                    </div>
                </div>
                <div id="characters" data-mercureurl="{{ mercureUrl }}" data-platformurl="{{ platformUrl }}"
                     data-slug="{{ slug }}" data-idplayer="{{ user.id }}"
                     data-idcurrentplayer="" data-owner="{{ roomUndercover.owner.id }}">
                    {% for user in roomUndercover.usersConnected %}
                        <div id="{{ user.id }}" class="container-char" onclick="onOpenPopupWord(this)">
                            <div class="nb-vote-{{ user.id }}"></div>
                            <div class="popup-word">
                                <div class="popup-word-title">Mots Précédents</div>
                                <div id="old-word-{{ user.id }}" class="old-word">
                                    {% for word in user.words %}
                                        <p><span class="tour-title">T? : </span><span
                                                    class="tour-word">{{ word }}</span></p>
                                    {% endfor %}
                                </div>
                            </div>
                            <div id="word-typed-{{ user.id }}" class="word-typed">
                                <img id="img-writing-{{ user.id }}" class="img-writing"
                                     src="{{ asset('assets/images/random/writing.gif') }}" alt="">
                                Hello !
                            </div>
                            <img id="img-char-{{ user.id }}" class="img-char" alt="img-char" draggable="false"
                                 src="{{ user.skin.path }}"/>
                            <div class="pseudo">{{ user.username }}</div>
                        </div>
                    {% endfor %}
                </div>
            </div>
            <div id="main-bottom">
                <div id="input-text"
                     class="{% if user.id is not same as(roomUndercover.owner.id) %}show-input-text{% endif %}">
                    <input id="input-word" placeholder="En attente ..." type="text" autocomplete="off">
                    <label for="input-word"></label>
                    <div id="timer-me">
                        <div id="timer-full"></div>
                    </div>
                </div>
                <div id="action" class="{% if user.id is same as(roomUndercover.owner.id) %}show-owner-btn{% endif %}">
                    <button id="action-btn" onclick="onClickStartGame()">Lancer la partie</button>
                </div>
            </div>
        </div>
        <div id="main-popup"></div>
        <div id="main-popup-hud">
            <div id="main-popup-hud-header">
                <div id="main-popup-hud-title">Votez pour un joueur</div>
                <div id="main-popup-hud-close">
                    <button onclick="onMainPopupClose()">X</button>
                </div>
            </div>
            <div id="main-popup-long">
                {% if roomUndercover.status is same as constant('App\\Entity\\RoomUndercover::STATUS_VOTING') %}
                    {% for user in roomUndercover.usersConnected %}
                        <div id="char-general-{{ user.id }}" class="char-general">
                            <div id="char-avatar-{{ user.id }}" class="char-avatar profile">
                                <img class="top-profile-img" src="{{ asset('assets/images/skins/Tom.svg') }}" alt="">
                            </div>
                            <div id="char-name-{{ user.id }}" class="char-name">{{ user.username }}</div>
                            <div class="char-vote">
                                <button class="char-vote-btn" onclick="onClickButtonVote(this)" data-id="{{ user.id }}">
                                    Vote
                                </button>
                            </div>
                            {% for vote in user.vote %}
                                <div id="voted-from-{{ vote.fromUserId }}" title="{{ vote.fromUserUsername }}"
                                     class="char-avatar-voter profile">
                                    <img class="profile-voter" src="{{ asset('assets/images/skins/Tom.svg') }}" alt="">
                                </div>
                            {% endfor %}
                        </div>
                    {% endfor %}
                {% endif %}
            </div>
            {% if user.id is same as roomUndercover.owner.id %}
                <div id="validate-vote-btn">
                    <button onclick="onClickButtonValidateVote()">Valider les votes</button>
                </div>
            {% else %}
                <div id="validate-vote-btn">
                    <button>En attente du leader</button>
                </div>
            {% endif %}
        </div>
        <div id="victory-overlay"></div>
        <div id="victory-overlay-hud">
            <img id="img-victory" draggable="false" src=""/>
            <div id="button-end">
                {% if user.id is same as(roomUndercover.owner.id) %}
                    <button id="waiting-another-room-onwer" class="waiting" onclick="newParty()">Lancer une nouvelle
                        partie
                    </button>
                {% else %}
                    <button id="waiting-another-room" class="waiting">En attente du nouveau salon...</button>
                {% endif %}
                <button id="return-home">Accueil</button>
            </div>
        </div>
        <div id="mrwhite-overlay"></div>
        <div id="container-card">
            <div id="card-reveal-front"><img src="{{ asset('assets/images/form/Spy.png') }}" alt=""></div>
            <div id="card-reveal" class="revealCivil">
                <!-- card-reveal-civils/card-reveal-undercover/card-reveal-mrwhite -->
                <div class="circle-face-reval">
                    <img id="img-reveal" draggable="false" src="" alt=""/>
                </div>
                <div id="card-pseudo">
                    <div id="card-pseudo-name">Splliter</div>
                    etait un
                </div>
                <div id="card-role">Undercover</div>
            </div>
        </div>

        <div id="container-mrwhite">
            <div id="timer-container-mrwhite">
                <div class="circle-skin-mrwhite">
                    <img id="skin-container-mrWhite" src="" alt=""/>
                </div>
                <div id="timer-mrwhite"></div>
            </div>

            <div id="guessword-mrwhite">
                <p>Devine le mot des civils</p>
                <input id="input-mrWhite" type="text">
                <button id="validate-input-mrWhite">Valider</button>
            </div>
        </div>

        <div id="container-waitfor-mrwhite">
            <div id="text-waitfor-mrwhite">
                <div id="title-waitfor-mrwhite">Mr White</div>
                <p>devine le mot</p></div>
            <div id="circle-skin-mrWhite" class="circle-skin-waitfor-mrwhite ">
                <!-- ajouter la class apres que mh à trouver + son   valid-mh/invalid-mh -->
                <img id="skin-container-waitfor-mrWhite" src="" alt=""/>
            </div>
            <div id="timer-others"></div>
        </div>

        <div id="container-equality">
            <div id="equality-popup">
                <div id="logo-equality"><img draggable="false" src="{{ asset('assets/images/random/law.svg') }}"
                                             alt=""/></div>
                <div id="equality-text">
                    <h4>Egalité des votes</h4>
                    <p>LE VILLAGE N'AS PAS RÉUSSI À SE DÉCIDER</p>
                </div>
            </div>
        </div>

        <audio id="audio-defeat" style="display: none" src="{{ asset('assets/sounds/defeat.mp3') }}"></audio>
        <audio id="audio-equality" style="display: none" src="{{ asset('assets/sounds/equality.mp3') }}"></audio>
        <audio id="audio-max-char" style="display: none" src="{{ asset('assets/sounds/max-car.mp3') }}"></audio>
        <audio id="audio-mh-fail" style="display: none" src="{{ asset('assets/sounds/mh-fail.mp3') }}"></audio>
        <audio id="audio-mh-success" style="display: none" src="{{ asset('assets/sounds/mh-success.mp3') }}"></audio>
        <audio id="audio-reveal-card" style="display: none" src="{{ asset('assets/sounds/reveal-card.mp3') }}"></audio>
        <audio id="audio-ticking" style="display: none" src="{{ asset('assets/sounds/ticking.mp3') }}"></audio>
        <audio id="audio-timeStart" style="display: none" src="{{ asset('assets/sounds/timerstart.mp3') }}"></audio>
        <audio id="audio-victory" style="display: none" src="{{ asset('assets/sounds/victory.mp3') }}"></audio>
    </main>
{% endblock %}

{% block javascripts %}
    <script>
        const audioDefeat = document.getElementById("audio-defeat");
        audioDefeat.volume = 0.2;
        const audioMaxChar = document.getElementById("audio-max-char");
        audioMaxChar.volume = 0.2;
        const audioMhFail = document.getElementById("audio-mh-fail");
        audioMhFail.volume = 0.2;
        const audioMhSuccess = document.getElementById("audio-mh-success");
        audioMhSuccess.volume = 0.2;
        const audioTicking = document.getElementById("audio-ticking");
        audioTicking.volume = 0.2;
        const audioTimeStart = document.getElementById("audio-timeStart");
        audioTimeStart.volume = 0.2;
        const audioVictory = document.getElementById("audio-victory");
        audioVictory.volume = 0.2;
        const audioRevealCard = document.getElementById("audio-reveal-card");
        audioRevealCard.volume = 0.2;
        const audioEquality = document.getElementById("audio-equality");
        audioEquality.volume = 0.2;

        const inputText = document.getElementById('input-text');
        const helloMessages = Array('Salut !', 'Bonjour.', 'Wesh ?!', 'Yo !', 'Hello !!', 'Zumba Cafew', 'Jul <3');

        const groupeUsers = document.getElementById('characters');

        /* -------------------------------------------------------- */
        /* Gère la connection au websocket                          */
        /* -------------------------------------------------------- */
        const mercureUrl = groupeUsers.dataset.mercureurl;
        const platformUrl = groupeUsers.dataset.platformurl;
        const slug = groupeUsers.dataset.slug;

        const url = new URL(mercureUrl)
        url.searchParams.append('topic', platformUrl + '/mercure/' + slug);

        const eventSource = new EventSource(url);

        eventSource.onopen = (() => {
            fetch(platformUrl + '/connectionOpened/' + slug, {
                headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json'
                },
                method: "GET",
            })
        });

        /* -------------------------------------------------------- */
        /* Gère la déconnection au websocket                        */
        /* -------------------------------------------------------- */
        window.addEventListener('beforeunload', (e) => {
            fetch(platformUrl + '/connectionClosed/' + slug, {
                headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json'
                },
                method: "GET",
            })
        });

        /* -------------------------------------------------------- */
        /* INIT des variables du compteur                           */
        /* -------------------------------------------------------- */
        let interval = ""
        let totalTime = 15;
        let time = totalTime;
        let btnStartPressed = false

        const counter = document.getElementById('counter');
        const timerFull = document.getElementById('timer-full');
        const chrono = () => {
            if (time <= totalTime && time >= 10) {
                counter.innerText = time.toString();
            } else if (time >= 0) {
                counter.innerText = '0' + time.toString();
            }
            const widthTimerFull = (1 - (time / totalTime)) * 100;
            if (!(widthTimerFull > 100)) timerFull.style.width = widthTimerFull + '%';
            time--;
            if (
                time <= -1 &&
                (document.getElementById('characters').dataset.idplayer === document.getElementById('characters').dataset.idcurrentplayer)
            ) {
                clearInterval(interval)
                nextPlayer();
            }
        }

        let k = 1;
        const launchInterval = () => {
            time = totalTime
            k++;
            interval = setInterval(chrono, 1000)
        };

        const resetTimer = () => {
            counter.innerText = '00';
        };

        /* -------------------------------------------------------- */
        /* SEND MRWHITE RESPONSE                                    */
        /* -------------------------------------------------------- */
        const sendMrWhiteResponse = () => {
            if ((document.getElementById('role').textContent.toString() === "MRWHITE")) {
                clearInterval(intervalMrWhite);
                document.getElementById('timer-mrwhite').innerText = "";
                document.getElementById('timer-others').innerText = "";
                audioTicking.pause();

                const inputMrWhite = document.getElementById('input-mrWhite');
                const message = {
                    mrWhiteResponse: inputMrWhite.value
                }
                inputMrWhite.value = '';
                fetch(platformUrl + '/mrWhiteResponse/' + slug, {
                    headers: {
                        'Accept': 'application/json, text/plain, */*',
                        'Content-Type': "application/x-www-form-urlencoded",
                    },
                    method: "POST",
                    body: JSON.stringify({message})
                })
            }
        }

        /* -------------------------------------------------------- */
        /* COMPTEUR MRWHITE                                         */
        /* -------------------------------------------------------- */
        let intervalMrWhite = "";
        timeMrWhite = 15;
        const timerMrWhite = document.getElementById('timer-mrwhite');
        const timerOthers = document.getElementById('timer-others');

        const launchMrWhiteInterval = () => {
            timeMrWhite = 15
            intervalMrWhite = setInterval(chronoMrWhite, 1000);
        }

        const chronoMrWhite = () => {
            timerMrWhite.innerText = timeMrWhite
            timerOthers.innerText = timeMrWhite
            timeMrWhite--;
            if (timeMrWhite <= -1) {
                timeMrWhite = 15;
                clearInterval(intervalMrWhite);
                sendMrWhiteResponse();
            }
        }

        /* -------------------------------------------------------- */
        /* INPUT MRWHITE                                            */
        /* -------------------------------------------------------- */
        const inputMrWhite = document.getElementById('input-mrWhite');
        const validateInputMrWhite = document.getElementById('validate-input-mrWhite');
        inputMrWhite.addEventListener('keyup', (event) => {
            if (event.keyCode === 13) {
                sendMrWhiteResponse();
            }
        });

        validateInputMrWhite.addEventListener('click', () => {
            sendMrWhiteResponse();
        });

        /* -------------------------------------------------------- */
        /* BUTTON QUI LANCE LA GAME                                 */
        /* -------------------------------------------------------- */
        const onClickStartGame = () => {
            document.getElementById('action').classList.remove('show-owner-btn')
            document.getElementById('input-text').classList.add('show-input-text')
            fetch(platformUrl + '/startGame/' + slug, {
                headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json'
                },
                method: "GET",
            })
        }

        /* -------------------------------------------------------- */
        /* FUNCTION QUI SE LANCE VIA LE TIMER OU LE BUTTON START    */
        /* OU AUTRES ACTION NECESSITANT DE TROUVER LE PROCHAIN      */
        /* JOUEUR A JOUER                                           */
        /* -------------------------------------------------------- */
        let anotherRound = false;
        const nextPlayer = () => {
            const message = {
                userPlayed: groupeUsers.dataset.idcurrentplayer
            }
            if (
                (groupeUsers.dataset.idplayer === groupeUsers.dataset.idcurrentplayer)
                || ((groupeUsers.dataset.idplayer === groupeUsers.dataset.owner) && !btnStartPressed)
                || ((groupeUsers.dataset.idplayer === groupeUsers.dataset.owner) && anotherRound)
            ) {
                btnStartPressed = true;
                anotherRound = false;
                fetch(platformUrl + '/counterTimedOut/' + slug, {
                    headers: {
                        'Accept': 'application/json, text/plain, */*',
                        'Content-Type': "application/x-www-form-urlencoded",
                    },
                    method: "POST",
                    body: JSON.stringify({message})
                })
            }
        }

        /* -------------------------------------------------------- */
        /* BUTTON QUI VALIDE LES VOTES PAR LE OWNER                 */
        /* -------------------------------------------------------- */
        const onClickButtonValidateVote = () => {
            fetch(platformUrl + '/validateVote/' + slug, {
                headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json'
                },
                method: "GET",
            })
        }

        /* -------------------------------------------------------- */
        /* ACTION QUI OUVRE LA POPUP DE VOTE                        */
        /* -------------------------------------------------------- */
        const onOpenVotePopup = () => {
            document.getElementById('main-popup').style.display = 'flex';
            document.getElementById('main-popup-hud').style.display = 'block';
        }

        /* -------------------------------------------------------- */
        /* EVENT LISTENER SUR L'INPUT LORSQU'ON APPUIE SUR ENTRER   */
        /* -------------------------------------------------------- */
        document.getElementById('input-word').addEventListener('keyup', (event) => {
            if (event.keyCode === 13) {
                const inputWord = document.getElementById('input-word');
                inputWord.setAttribute("disable", "disable");
                const message = {
                    message: document.getElementById("input-word").value
                }
                inputWord.value = '';
                fetch(platformUrl + '/mercure/' + slug, {
                    headers: {
                        'Accept': 'application/json, text/plain, */*',
                        'Content-Type': "application/x-www-form-urlencoded",
                    },
                    method: "POST",
                    body: JSON.stringify({message})
                })
            }
        });

        /* -------------------------------------------------------- */
        /* BUTTON QUI VOTE POUR QQL                                 */
        /* -------------------------------------------------------- */
        const onClickButtonVote = (e) => {
            const message = {
                userToVoteOn: e.dataset.id,
            }
            fetch(platformUrl + '/vote/' + slug, {
                headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': "application/x-www-form-urlencoded",
                },
                method: "POST",
                body: JSON.stringify({message})
            })
        }

        eventSource.onmessage = (e) => {
            const data = JSON.parse(e.data);

            console.log(data);

            switch (Object.keys(data)[0]) {

                case 'onStart':

                    const guessWord = document.getElementById('guess-word');
                    const role = document.getElementById('role');
                    const id = document.getElementById('characters').dataset.idplayer;

                    for (let i = 0; i < data.onStart.users.length; i++) {
                        if (data.onStart.users[i].id.toString() === id.toString()) {
                            if (data.onStart.users[i].role === "CIVIL") {
                                guessWord.innerHTML = data.onStart.civilWord;
                                role.innerHTML = 'CIVIL';
                                role.style.display = 'flex';
                                role.classList.add('civil')
                            } else if (data.onStart.users[i].role === "UNDERCOVER") {
                                guessWord.innerHTML = data.onStart.undercoverWord;
                                role.innerHTML = 'UNDERCOVER';
                                role.style.display = 'flex';
                                role.classList.add('undercover')
                            } else if (data.onStart.users[i].role === "MRWHITE") {
                                guessWord.innerHTML = '...';
                                role.innerHTML = 'MRWHITE';
                                role.style.display = 'flex';
                                role.classList.add('mrWhite')
                            }
                        }
                    }

                    const wordsTyped = document.getElementsByClassName('word-typed');

                    for (let i = 0; i < wordsTyped.length; i++) {
                        wordsTyped[i].innerText = '';
                    }

                    nextPlayer();
                    break;

                case 'onSubscribe':

                    const isAlreadyExist = document.getElementById(data.onSubscribe.userId.toString())

                    if (!isAlreadyExist) {

                        /* <div id="{user.id}" class="container-char" onclick="onOpenPopupWord(this)"> */
                        const divContainerChar = document.createElement('div');
                        divContainerChar.classList.add('container-char');
                        divContainerChar.setAttribute('onclick', 'onOpenPopupWord(this)');
                        divContainerChar.id = data.onSubscribe.userId.toString();

                        /* <div id="nb-vote-{user.id}" class="nb-vote"></div> */
                        const divNbVote = document.createElement('div');
                        divNbVote.classList.add('nb-vote')
                        divNbVote.id = 'nb-vote-' + data.onSubscribe.userId.toString();

                        /* <div class="popup-word"> */
                        const divPopupWord = document.createElement('div');
                        divPopupWord.classList.add('popup-word');

                        /* <div class="popup-word-title"> */
                        const divPopupWordTitle = document.createElement('div');
                        const textPopupWordTitle = document.createTextNode('Mots Précédents');
                        divPopupWordTitle.classList.add('popup-word-title');
                        divPopupWordTitle.appendChild(textPopupWordTitle);

                        /* <div id="old-word-{user.id}" class="old-word"> */
                        const divOldWord = document.createElement('div');
                        divOldWord.classList.add('old-word');
                        divOldWord.id = 'old-word-' + data.onSubscribe.userId.toString();

                        data.onSubscribe.words.forEach((word) => {
                            const p = document.createElement('p');
                            /* TODO PASSER LE NB DE TOUR */
                            const spanTourTitle = document.createElement('span');
                            const textTourTitle = document.createTextNode('T{N} : ');
                            spanTourTitle.classList.add('tour-title');
                            textTourTitle.appendChild(textTourTitle);

                            const spanTourWord = document.createElement('span');
                            const textTourWord = document.createTextNode(word);
                            spanTourWord.classList.add('tour-word');
                            spanTourWord.appendChild(textTourWord);

                            p.appendChild(spanTourTitle);
                            p.appendChild(spanTourWord);

                            divOldWord.prepend(p);
                        })

                        divPopupWord.appendChild(divPopupWordTitle);
                        divPopupWord.appendChild(divOldWord);

                        /* <div class="word-typed"></div> */
                        const divWordTyped = document.createElement('div');
                        // const imgWriting = document.createElement('img');
                        // imgWriting.id = 'img-writing-' + data.onSubscribe.userId.toString();
                        // imgWriting.setAttribute('src', '/assets/images/random/writing.gif');
                        // imgWriting.classList.add('img-writing');
                        // divWordTyped.appendChild(imgWriting);
                        const textWordType = document.createTextNode(helloMessages[Math.floor(Math.random() * helloMessages.length)])
                        divWordTyped.classList.add('word-typed');
                        divWordTyped.appendChild(textWordType);
                        divWordTyped.id = 'word-typed-' + data.onSubscribe.userId.toString();

                        const img = document.createElement('img');
                        img.classList.add('img-char');
                        img.setAttribute('alt', 'img-avatar');
                        img.setAttribute('draggable', 'false');
                        img.setAttribute('src', data.onSubscribe.skinPath);
                        img.id = 'img-char-' + data.onSubscribe.userId.toString();

                        const divPseudo = document.createElement('div');
                        const textPseudo = document.createTextNode(data.onSubscribe.username);
                        divPseudo.appendChild(textPseudo);
                        divPseudo.classList.add('pseudo');

                        divContainerChar.appendChild(divNbVote);
                        divContainerChar.appendChild(divPopupWord);
                        divContainerChar.appendChild(divWordTyped);
                        divContainerChar.appendChild(img);
                        divContainerChar.appendChild(divPseudo);

                        groupeUsers.appendChild(divContainerChar);

                    } else {

                        isAlreadyExist.classList.remove('disconnect');
                        const divWordTypedDisconnect = document.getElementById('word-typed-' + data.onSubscribe.userId.toString());
                        divWordTypedDisconnect.classList.remove('disconnect');
                        const imgCharDisconnect = document.getElementById('img-char-' + data.onSubscribe.userId.toString());
                        imgCharDisconnect.classList.remove('disconnect');

                    }

                    break;

                case 'onUnsubscribe':

                    const divUserToDisconnect = document.getElementById(data.onUnsubscribe.userId);
                    if (divUserToDisconnect) {
                        if (data.onUnsubscribe.gameStatus !== 'WAITING') {
                            divUserToDisconnect.classList.add('disconnect');
                            const divWordTypedDisconnect = document.getElementById('word-typed-' + data.onUnsubscribe.userId.toString());
                            divWordTypedDisconnect.classList.add('disconnect');
                            const imgCharDisconnect = document.getElementById('img-char-' + data.onUnsubscribe.userId.toString());
                            imgCharDisconnect.classList.add('disconnect');
                        } else {
                            divUserToDisconnect.parentElement.removeChild(divUserToDisconnect);
                        }
                    }

                    break;

                case 'message':

                    const divWordTyped = document.getElementById('word-typed-' + data.message.userId.toString());
                    const textWordType = document.createTextNode(data.message.message);
                    divWordTyped.innerText = '';
                    divWordTyped.appendChild(textWordType);

                    const divOldWord = document.getElementById('old-word-' + data.message.userId.toString())
                    if (data.message.previousWord) {
                        const p = document.createElement('p');
                        const spanTourTitle = document.createElement('span');
                        spanTourTitle.classList.add('tour-title');
                        const textTourTitle = document.createTextNode("T" + (data.message.currentTurn - 1) + " : ");
                        spanTourTitle.appendChild(textTourTitle);

                        const spanTourWord = document.createElement('tour-word');
                        spanTourWord.classList.add('tour-word');
                        const textTourWord = document.createTextNode(data.message.previousWord);
                        spanTourWord.appendChild(textTourWord);

                        p.appendChild(spanTourTitle);
                        p.appendChild(spanTourWord);

                        divOldWord.prepend(p);
                    }

                    time = totalTime;
                    clearInterval(interval)
                    nextPlayer();

                    break

                case 'onCounterTimedOut':

                    const inputWord = document.getElementById('input-word');

                    audioTimeStart.volume = 0;

                    if (data.onCounterTimedOut.turnOngoing) {

                        const spanCurrentTurn = document.getElementById('current-turn');
                        spanCurrentTurn.innerText = data.onCounterTimedOut.currentTurn;

                        inputWord.setAttribute('disabled', 'disabled');
                        inputWord.setAttribute('placeholder', "C'est au tour de " + data.onCounterTimedOut.username);

                        // const imgsWaiting = document.getElementsByClassName('img-writing');
                        // for (let u = 0; u < imgsWaiting.length; u++) {
                        //     imgsWaiting[0].style.display = 'none';
                        // }
                        // const imgWriting = document.getElementById('img-writing-' + data.onCounterTimedOut.userId.toString());
                        // console.log(data.onCounterTimedOut.userId.toString(), imgsWaiting)
                        // imgWriting.style.display = 'block';

                        const characters = document.getElementById('characters');
                        characters.dataset.idcurrentplayer = data.onCounterTimedOut.userId;

                        //MET UN HALO LUMINEUX SUR LE JOUEUR COURANT
                        const containerChars = document.getElementsByClassName('container-char');
                        for (let p = 0; p < containerChars.length; p++) {
                            containerChars[p].classList.remove('active-player');
                            containerChars[p].classList.remove('active-player-small');
                        }

                        const currentContainerChar = document.getElementById(data.onCounterTimedOut.userId.toString());
                        currentContainerChar.classList.add('active-player');

                        if (data.onCounterTimedOut.userId.toString() === document.getElementById('characters').dataset.idplayer) {
                            inputWord.removeAttribute('disabled');
                            inputWord.focus();
                            audioTimeStart.play();
                            audioTimeStart.volume = 0.2;
                        }

                        clearInterval(interval);
                        launchInterval();

                    } else {

                        //Reset party params on vote
                        time = totalTime;
                        clearInterval(interval);
                        resetTimer();
                        groupeUsers.dataset.idcurrentplayer = "";

                        //Remove all HAlO from players
                        const containerChars = document.getElementsByClassName('container-char');
                        for (let p = 0; p < containerChars.length; p++) {
                            containerChars[p].classList.remove('active-player');
                            containerChars[p].classList.remove('active-player-small');
                        }

                        inputWord.setAttribute('disabled', 'disabled');

                        const inputText = document.getElementById('input-text');
                        inputText.classList.remove('show-input-text');

                        const action = document.getElementById('action');
                        action.style.display = 'flex';

                        const buttonAction = document.getElementById('action-btn');
                        buttonAction.setAttribute('onclick', 'onOpenVotePopup()');
                        buttonAction.innerText = 'Voir les votes';

                        const divMainPopupLong = document.getElementById('main-popup-long');

                        let players = document.getElementById('characters').children;

                        for (let i = 0; i < players.length; i++) {

                            let containerChar = players[i]

                            if (!document.getElementById('char-general-' + containerChar.id)) {
                                const divCharGeneral = document.createElement('div');
                                divCharGeneral.classList.add('char-general');
                                divCharGeneral.id = 'char-general-' + containerChar.id;

                                const divCharAvatar = document.createElement('div');
                                divCharAvatar.classList.add('char-avatar')
                                // AJOUTER LA CLASSE DE L'AVATAR
                                divCharAvatar.classList.add('profile');
                                divCharAvatar.id = 'char-avatar-' + containerChar.id;
                                const imgTopProfile = document.createElement('img')
                                imgTopProfile.classList.add('top-profile-img');
                                imgTopProfile.setAttribute('src', document.getElementById('img-char-' + containerChar.id).src);
                                divCharAvatar.appendChild(imgTopProfile);

                                const divCharName = document.createElement('div');
                                divCharName.classList.add('char-name');
                                divCharName.innerText = containerChar.getElementsByClassName('pseudo')[0].textContent;
                                divCharName.id = 'char-name-' + containerChar.id;

                                const divCharVote = document.createElement('div');
                                divCharVote.classList.add('char-vote');
                                const buttonCharVote = document.createElement('button');
                                buttonCharVote.classList.add('char-vote-btn');
                                buttonCharVote.setAttribute('onclick', 'onClickButtonVote(this)');
                                buttonCharVote.dataset.id = containerChar.id;
                                buttonCharVote.innerText = 'Vote';
                                divCharVote.appendChild(buttonCharVote);

                                divCharGeneral.appendChild(divCharAvatar);
                                divCharGeneral.appendChild(divCharName);
                                divCharGeneral.appendChild(divCharVote);

                                divMainPopupLong.appendChild(divCharGeneral);
                            }
                        }

                        const divMainPopupOverlay = document.getElementById('main-popup')
                        const divMainPopup = document.getElementById('main-popup-hud')
                        divMainPopupOverlay.style.display = 'flex'
                        divMainPopup.style.display = 'block'
                    }

                    break;

                case 'onVote':

                    const previousVote = document.getElementById('voted-from-' + data.onVote.userId);
                    if (previousVote) {
                        previousVote.remove();
                    }

                    const divCharGeneral = document.getElementById('char-general-' + data.onVote.voteOnUserId);

                    const divVotedFrom = document.createElement('div');
                    divVotedFrom.id = 'voted-from-' + data.onVote.userId;
                    divVotedFrom.setAttribute('title', data.onVote.username);
                    divVotedFrom.classList.add('char-avatar-voter');
                    divVotedFrom.classList.add('profile');
                    const imgVoter = document.createElement('img')
                    imgVoter.classList.add('profile-voter');
                    imgVoter.setAttribute('src', document.getElementById('img-char-' + data.onVote.userId).src);
                    divVotedFrom.appendChild(imgVoter);

                    divCharGeneral.appendChild(divVotedFrom);

                    break;

                case 'onValidateVote':

                    const divPopupVote = document.getElementById('main-popup-hud');
                    const divPopupVoteOverlay = document.getElementById('main-popup');
                    divPopupVote.style.display = "none";
                    divPopupVoteOverlay.style.display = "none";

                    const inputText = document.getElementById('input-text');
                    inputText.classList.add('show-input-text');

                    const action = document.getElementById('action');
                    action.style.display = 'none';

                    //Remove all votes
                    var divPopupLong = document.getElementById("main-popup-long");
                    divPopupLong.querySelectorAll('*').forEach(n => n.remove());

                    // SI IL Y A EGALITE ON PASSE LE VOTE
                    if (data.onValidateVote.isEquality) {

                        const wordsTyped = document.getElementsByClassName('word-typed');
                        for (let x = 0; x < wordsTyped.length; x++) {
                            wordsTyped[x].innerText = '';
                        }

                        const divEqualityPopup = document.getElementById('container-equality');
                        divEqualityPopup.style.display = 'flex';
                        audioEquality.play();
                        setTimeout(() => {
                                divEqualityPopup.style.display = 'none';
                                anotherRound = true;
                                nextPlayer();
                        }, 6000)

                    } else {

                        const imgVictory = document.getElementById('img-victory');
                        const victoryHud = document.getElementById('victory-overlay-hud');
                        const victoryOverlay = document.getElementById('victory-overlay');


                        // SI C'EST UNE GAME AVEC ELIMINATION
                        // SINON PAS D'ELIMINATION & DECLARER LE VAINQUEUR
                        if (data.onValidateVote.isElimination) {

                            // SI IL Y A UN VAINQUEUR, DECLARER LE VAINQUEUR
                            // SINON PASSER LE JOUEUR ELIMINER EN ELIMINER
                            if (data.onValidateVote.isWinners) {

                                const role = document.getElementById('role').textContent;

                                if (data.onValidateVote.winnerData.whoHasWin === "CIVILS") {
                                    imgVictory.setAttribute('src', "/assets/images/victory/civils.svg")
                                    victoryOverlay.style.display = 'flex';
                                    victoryHud.style.display = 'flex';
                                    if ((role === "UNDERCOVER")
                                        || (role === "MRWHITE")
                                    ) {
                                        setTimeout(() => {
                                            audioDefeat.play()
                                        }, 800)
                                    } else {
                                        setTimeout(() => {
                                            audioVictory.play();
                                        }, 800)
                                    }
                                } else if (data.onValidateVote.winnerData.whoHasWin === "UNDERCOVER") {
                                    imgVictory.setAttribute('src', "/assets/images/victory/undercover.svg")
                                    victoryOverlay.style.display = 'flex';
                                    victoryHud.style.display = 'flex';
                                    if ((role === "CIVIL")
                                        || (role === "MRWHITE")
                                    ) {
                                        setTimeout(() => {
                                            audioDefeat.play()
                                        }, 800)
                                    } else {
                                        setTimeout(() => {
                                            audioVictory.play();
                                        }, 800)
                                    }
                                } else if (data.onValidateVote.winnerData.whoHasWin === "MRWHITE") {
                                    imgVictory.setAttribute('src', "/assets/images/victory/mrwhite.svg")
                                    victoryOverlay.style.display = 'flex';
                                    victoryHud.style.display = 'flex';
                                    if ((role === "UNDERCOVER")
                                        || (role === "CIVIL")
                                    ) {
                                        setTimeout(() => {
                                            audioDefeat.play()
                                        }, 800)
                                    } else {
                                        setTimeout(() => {
                                            audioVictory.play();
                                        }, 800)
                                    }
                                }

                            } else {

                                const eliminatedOverlay = document.getElementById('mrwhite-overlay');

                                const countMrWhite = document.getElementById('countMrWhite');
                                const countUndercover = document.getElementById('countUndercover');

                                const eliminatedOverlayHud = document.getElementById('container-card');
                                const eliminatedOverlayRole = document.getElementById('card-role');
                                const eliminatedOverlayUsername = document.getElementById('card-pseudo-name');
                                const imgReveal = document.getElementById('img-reveal');
                                const cardReveal = document.getElementById('card-reveal');

                                cardReveal.className = '';

                                eliminatedOverlayUsername.innerText = data.onValidateVote.eliminatedData.userName;
                                eliminatedOverlayRole.innerText = data.onValidateVote.eliminatedData.userRole;
                                imgReveal.setAttribute('src', data.onValidateVote.eliminatedData.userAvatar);
                                if (data.onValidateVote.eliminatedData.userRole === "CIVIL") {
                                    cardReveal.classList.add('revealCivil');
                                    // cardReveal.style.display = 'flex';
                                } else if (data.onValidateVote.eliminatedData.userRole === "UNDERCOVER") {
                                    cardReveal.classList.add('revealUndercover');
                                    // cardReveal.style.display = 'flex';
                                } else {
                                    cardReveal.classList.add('revealMrWhite');
                                    // cardReveal.style.display = 'flex';
                                }
                                audioRevealCard.play();
                                eliminatedOverlay.style.display = 'flex';
                                eliminatedOverlayHud.style.display = 'flex';

                                countMrWhite.innerText = data.onValidateVote.countMrWhite;
                                countUndercover.innerText = data.onValidateVote.countUndercover;

                                const containerChar = document.getElementById(data.onValidateVote.eliminatedData.userId);
                                const wordsTyped = document.getElementsByClassName('word-typed');
                                for (let x = 0; x < wordsTyped.length; x++) {
                                    wordsTyped[x].innerText = '';
                                }
                                anotherRound = true;

                                setTimeout(() => {

                                    containerChar.style.opacity = "0.2";
                                    containerChar.getElementsByClassName('popup-word')[0].remove();
                                    containerChar.getElementsByClassName('word-typed')[0].style.display = 'none';

                                    eliminatedOverlay.style.display = 'none';
                                    eliminatedOverlayHud.style.display = 'none';

                                    // SI MRWHITE EST ELIMINE
                                    if (data.onValidateVote.eliminatedData.isMrWhite) {

                                        //SET SKIN OF MRWHITE
                                        const skinContainerMrWhite = document.getElementById('skin-container-mrWhite');
                                        const skinContainerOthers = document.getElementById('skin-container-waitfor-mrWhite');
                                        skinContainerMrWhite.setAttribute('src', data.onValidateVote.eliminatedData.userAvatar);
                                        skinContainerOthers.setAttribute('src', data.onValidateVote.eliminatedData.userAvatar);

                                        const divContainerMrWhite = document.getElementById('container-mrwhite');
                                        const divContainerWaitForMrMister = document.getElementById('container-waitfor-mrwhite');
                                        eliminatedOverlay.style.display = 'flex';
                                        launchMrWhiteInterval();

                                        const role = document.getElementById('role').textContent;
                                        // DISPLAY THE RIGHT CONTAINER FOR THE PLAYERS
                                        audioTicking.play();
                                        if (role === "MRWHITE") {

                                            divContainerMrWhite.style.display = 'flex';

                                        } else {

                                            divContainerWaitForMrMister.style.display = 'flex';

                                        }

                                    } else {
                                        nextPlayer();
                                    }
                                }, 6000);
                            }

                        } else {

                            // TODO : DECLARER LES VAINQUEURS DE LA GAME SANS ELIMINATION
                            const eliminatedData = data.onValidateVote;

                            if (eliminatedData.winnerData.whoHasWin === "CIVILS") {
                                imgVictory.setAttribute('src', "/assets/images/victory/civils.svg")
                                victoryOverlay.style.display = 'flex';
                                victoryHud.style.display = 'flex';
                            } else if (eliminatedData.winnerData.whoHasWin === "UNDERCOVER") {
                                imgVictory.setAttribute('src', "/assets/images/victory/undercover.svg")
                                victoryOverlay.style.display = 'flex';
                                victoryHud.style.display = 'flex';
                            }
                        }
                    }

                    break;

                case 'onMrWhiteResponse':

                    //STOP COUNTER
                    document.getElementById('timer-others').innerText = "";
                    clearInterval(intervalMrWhite);
                    audioTicking.pause();

                    const eliminatedOverlay = document.getElementById('mrwhite-overlay');
                    const divContainerMrWhite = document.getElementById('container-mrwhite')
                    const divContainerWaitForMrMister = document.getElementById('container-waitfor-mrwhite')
                    const divCircleSkinMrWhite = document.getElementById('circle-skin-mrWhite')

                    divContainerMrWhite.style.display = 'none';
                    divContainerWaitForMrMister.style.display = 'flex';

                    if (data.onMrWhiteResponse.hasFound) {

                        //TODO STOP GAME MRWHITE IS WINNER

                        //PLAY SOUND
                        audioMhSuccess.play();

                        setTimeout(() => {

                            divCircleSkinMrWhite.classList.add('valid-mh');

                            setTimeout(() => {

                                eliminatedOverlay.style.display = 'none'
                                const role = document.getElementById('role').textContent;
                                const imgVictory = document.getElementById('img-victory');
                                const victoryHud = document.getElementById('victory-overlay-hud');
                                const victoryOverlay = document.getElementById('victory-overlay');

                                imgVictory.setAttribute('src', "/assets/images/victory/mrwhite.svg")
                                victoryOverlay.style.display = 'flex';
                                victoryHud.style.display = 'flex';
                                if ((role === "UNDERCOVER")
                                    || (role === "CIVIL")
                                ) {
                                    setTimeout(() => {
                                        audioDefeat.play()
                                    }, 800)
                                } else {
                                    setTimeout(() => {
                                        audioVictory.play();
                                    }, 800)
                                }

                            }, 6000)

                        }, 2500);

                    } else {

                        //TODO ELIMINER MRWHITE ET NEXTPLAYER()

                        //PLAY SOUND
                        audioMhFail.play();

                        setTimeout(() => {

                            divCircleSkinMrWhite.classList.add('invalid-mh');

                            setTimeout(() => {

                                eliminatedOverlay.style.display = 'none'
                                divContainerWaitForMrMister.style.display = 'none';
                                divContainerWaitForMrMister.style.display = 'none';
                                divCircleSkinMrWhite.classList.remove('invalid-mh');

                                nextPlayer();

                            }, 6000)

                        }, 2500);
                    }

                    break;
            }
        };

        /* -------------------------------------------------------- */
        /* BUTTON POUR LAANCER UNE NOUVELLE GAME                    */
        /* -------------------------------------------------------- */
        const newParty = () => {
            // FETCH
        }
    </script>
    <script>
        const onOpenPopupWord = (el) => {
            let popup = null;
            let pastille = null;
            for (let i = 0; i < el.childNodes.length; i++) {
                if (el.childNodes[i].className === "popup-word") {
                    popup = el.childNodes[i];
                    break;
                }
            }
            for (let i = 0; i < el.childNodes.length; i++) {
                if (el.childNodes[i].className === "nb-vote") {
                    pastille = el.childNodes[i];
                    break;
                }
            }
            if (popup) {
                if (popup.style.display === "block") {
                    popup.style.display = "none";
                    // pastille.style.left = "50%";
                } else {
                    popup.style.display = "block";
                    // pastille.style.left = "100%";
                }
            }
        }

        const onMainPopupClose = () => {
            document.getElementById("main-popup-hud").style.display = "none";
            document.getElementById("main-popup").style.display = "none";
        }
    </script>
{% endblock %}
